package com.digiwin.athena.app.service.purchase;

import com.digiwin.app.service.DWEAIResult;
import com.digiwin.athena.app.infra.common.utils.TransferUtil;
import com.digiwin.athena.app.infra.dto.PurchaseOrderDetailDTO;
import com.digiwin.athena.app.infra.entity.PurchaseOrderDetailEntity;
import com.digiwin.athena.app.infra.service.PurchaseDemoService;
import com.digiwin.athena.opt.common.eai.EAIUtil;
import com.digiwin.athena.opt.common.eai.service.AbsEAIService;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @author lz
 * @description 创建请购单
 * @throws
 * @time 2023/8/29 16:16
 */
@Service
public class PurchaseDemoCreateService extends AbsEAIService {

    @Resource
    PurchaseDemoService purchaseDemoService;

    @Override
    public String getServiceName() {
        return PurchaseUtil.DEMO_PURCHASE_DEMO_CREATE;
    }

    @Override
    public DWEAIResult execute(Map<String, String> headers, String messageBody) throws Exception {
        //将入参值转换为DTO
        List<PurchaseOrderDetailDTO> purchaseOrderDetailDTOS = TransferUtil.string2List(messageBody, PurchaseOrderDetailDTO.class, "purchase_info");

        //插入数据库
        List<PurchaseOrderDetailEntity> entities = purchaseOrderDetailDTOS.stream()
                .map(dto -> {
                    PurchaseOrderDetailEntity entity = new PurchaseOrderDetailEntity();
                    BeanUtils.copyProperties(dto, entity);
                    return entity;
                })
                .collect(Collectors.toList());
        purchaseDemoService.saveBatch(entities);

        return EAIUtil.buildEAIResult(new HashMap<>());
    }
}
